package NewsFeedPublisher.web;

import java.io.IOException;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import NewsFeedPublisher.data.User;
import NewsFeedPublisher.data.UserDAO;

public class CreateUserServlet extends HttpServlet {
	
	private Logger logger = Logger.getLogger(this.getClass());
	private RequestDispatcher jsp;
	
	public void init(ServletConfig config) throws ServletException {
		
		ServletContext context = config.getServletContext();
		jsp = context.getRequestDispatcher("/WEB-INF/jsp/edit-user.jsp");
	}
	
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		logger.debug("doGet()");
		jsp.forward(req, resp);
	}
	
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		String cancelButton = req.getParameter("cancel-button");
		if(cancelButton != null) {
			logger.debug("cancel button pressed");
			resp.sendRedirect("list-users");
			return;
		}
		Map<String,String> errors = EditUserServlet.validate(req);
		if(!errors.isEmpty()) {
			logger.debug("validation error(s) for create");
			jsp.forward(req, resp);
			return;
		}
		User user = (User) req.getAttribute("user");
		new UserDAO().create(user);
		resp.sendRedirect("view-user?id=" + user.getId());
	}
}