package NewsFeedPublisher.web;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import NewsFeedPublisher.data.NewsItem;
import NewsFeedPublisher.data.NewsItemDAO;

public class DeleteNewsItemServlet extends HttpServlet {
	
	private Logger logger = Logger.getLogger(this.getClass());
    private RequestDispatcher jsp;

	public void init(ServletConfig config) throws ServletException {
		
		ServletContext context = config.getServletContext();
	    jsp = context.getRequestDispatcher("/WEB-INF/jsp/delete-news-item.jsp");
	}
	   
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		logger.debug("doGet()");
		jsp.forward(req, resp);
	}
	
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		String idString = req.getParameter("id");
		String cancelButton = req.getParameter("cancel-button");
	    if (cancelButton != null) {
	    	logger.debug("cancel button pressed on delete");
	    	resp.sendRedirect("view-news-item?id=" + idString);
	    	return;
	    }
	    NewsItemDAO newsItemDAO = new NewsItemDAO();
	    Long id = new Long(idString);
	    NewsItem newsItem = newsItemDAO.find(id);
	    new NewsItemDAO().delete(newsItem);
	    resp.sendRedirect("list-news-items");
	}
}