package NewsFeedPublisher.web;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import NewsFeedPublisher.data.User;
import NewsFeedPublisher.data.UserDAO;

public class DeleteUserServlet extends HttpServlet {
	
	private Logger logger = Logger.getLogger(this.getClass());
    private RequestDispatcher jsp;

	public void init(ServletConfig config) throws ServletException {
		
		ServletContext context = config.getServletContext();
	    jsp = context.getRequestDispatcher("/WEB-INF/jsp/delete-user.jsp");
	}
	   
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		logger.debug("doGet()");
		jsp.forward(req, resp);
	}
	
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		String idString = req.getParameter("id");
		String cancelButton = req.getParameter("cancel-button");
	    if (cancelButton != null) {
	    	logger.debug("cancel button pressed on delete");
	    	resp.sendRedirect("view-user?id=" + idString);
	    	return;
	    }
	    UserDAO userDAO = new UserDAO();
	    Long id = new Long(idString);
	    User user = userDAO.find(id);
	    new UserDAO().delete(user);
	    resp.sendRedirect("list-users");
	}
}