package NewsFeedPublisher.web;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import NewsFeedPublisher.data.User;
import NewsFeedPublisher.data.UserDAO;

public class ListUsersServlet extends HttpServlet {
	
	private Logger logger = Logger.getLogger(this.getClass());
	private RequestDispatcher jsp;

	public void init(ServletConfig config) throws ServletException {
		ServletContext context = config.getServletContext();
	    jsp = context.getRequestDispatcher("/WEB-INF/jsp/list-users.jsp");
	}
	   
	   
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException{
	     logger.debug("doGet() -- list users");
	     List<User> users = new UserDAO().findall();
	     req.setAttribute("users", users);
	     jsp.forward(req, resp);
	}   
}