package NewsFeedPublisher.web;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;

public class SecurityFilter implements Filter {

	private Logger logger = Logger.getLogger(this.getClass());
	
	public void init(FilterConfig filterConfig) throws ServletException {
		
	}
	
	public void destroy() {

	}
	
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
		
		logger.debug("doFilter()");
		HttpServletRequest req = (HttpServletRequest) request;		
		HttpServletResponse resp = (HttpServletResponse) response;
		String servletPath = req.getServletPath();
		
		//allow access to login functionality
		if(servletPath.equals("/login)")) {
			logger.debug("doFilter() servlet path = login");
			chain.doFilter(req, resp);
			return;
		}
		
		//allow access to the news feed
		if(servletPath.equals("/news.rss)")) {
			chain.doFilter(req, resp);
			return;
		}
		
		if(servletPath.equals("/publish)")) {
			chain.doFilter(req, resp);
			return;
		}
		
		if(servletPath.equals("/unpublish)")) {
			chain.doFilter(req, resp);
			return;
		}
		
		//all other functionality requires authentication
		HttpSession session = req.getSession();
		Long userId = (Long) session.getAttribute("userId");
		if(userId != null) {
			chain.doFilter(req, resp);
			return;
		}
		
		//request is not authorized because user is not logged in 
		resp.sendRedirect("login");	
	}
}