package NewsFeedPublisher.web;

import java.io.IOException;
import java.util.List;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import NewsFeedPublisher.data.NewsItem;
import NewsFeedPublisher.data.NewsItemDAO;

public class ViewNewsItemServlet extends HttpServlet {
	
	private Logger logger = Logger.getLogger(this.getClass());
	private RequestDispatcher jsp;
	   
	public void init(ServletConfig config) throws ServletException {
		ServletContext context = config.getServletContext();
	    jsp = context.getRequestDispatcher("/WEB-INF/jsp/view-news-item.jsp");
	}
	
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		   
    	List<NewsItem> items = new NewsItemDAO().findAll();
    	Vector<Long> ids = new Vector<Long>();
    	for(NewsItem item : items){
    		ids.add(item.getId());
    	}
    	
    	logger.debug("doGet()");
        String idString = req.getParameter("id");
        Long id = new Long(idString);
        NewsItem newsItem = new NewsItemDAO().find(id);
        if(ids.contains(id)) {
        	req.setAttribute("newsItem", newsItem);
        	jsp.forward(req, resp);
        }
        else
        	resp.sendRedirect("list-news-items");
    }
}

