package NewsFeedPublisher.web;

import java.io.IOException;
import java.util.List;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import NewsFeedPublisher.data.User;
import NewsFeedPublisher.data.UserDAO;

public class ViewUserServlet extends HttpServlet {
	
    private Logger logger = Logger.getLogger(this.getClass());
    private RequestDispatcher jsp;
   
    public void init(ServletConfig config) throws ServletException {
    	ServletContext context = config.getServletContext();
        jsp = context.getRequestDispatcher("/WEB-INF/jsp/view-user.jsp");
    }
   
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
	   
    	List<User> users = new UserDAO().findall();
    	Vector<Long> ids = new Vector<Long>();
    	for(User user : users){
    		ids.add(user.getId());
    	}
    	
    	logger.debug("doGet()");
        String idString = req.getParameter("id");
        Long id = new Long(idString);
        User user = new UserDAO().find(id);
        if(ids.contains(id)) {
        	req.setAttribute("user", user);
        	jsp.forward(req, resp);
        }
        else
        	resp.sendRedirect("list-users");
    }
}